;ZX7 data decompressor for Apple II
;Peter Ferrie (peter.ferrie@gmail.com)
;assemble using ACME
;dst<src
;!cpu 65c02
;!to "zx7",plain
;*=$800

;unpacker variables, no need to change these
src	=	$0
dst	=	$2
ecx	=	$4
last	=	$6
tmp	=	$8
tmpy = $A
unpack ;unpacker entrypoint
	lda #0
	sta	last
	sta	ecx
	sta	ecx+1

dzx7s_copy_byte_loop:
	jsr	getput

dzx7s_main_loop:
	jsr	dzx7s_next_bit
	bcc	dzx7s_copy_byte_loop
	ldy	#0

dzx7s_len_size_loop:
	iny
	jsr	dzx7s_next_bit
	bcc	dzx7s_len_size_loop
	jmp	dzx7s_len_value_skip;bra

dzx7s_next_bit:
	asl	last
	bne	dzx7s_next_bit_ret
	jsr	getsrc
	sec
	rol
	sta	last

dzx7s_next_bit_ret:
	rts

dzx7s_len_value_loop:
	jsr	dzx7s_next_bit

dzx7s_len_value_skip:
	rol	ecx
	rol	ecx+1
	bcs	dzx7s_next_bit_ret
	dey
	bne	dzx7s_len_value_loop
	inc	ecx
	bne	bra1;+
	inc	ecx+1
bra1;+
	jsr	getsrc
	rol
	sta	tmp
	tya
	bcc	dzx7s_offset_end
	lda	#$10

dzx7s_rld_next_bit:
	pha
	jsr	dzx7s_next_bit
	pla
	rol
	bcc	dzx7s_rld_next_bit
	;inc
	clc
	adc #1
	lsr

dzx7s_offset_end:
	sta	tmp+1
	ror	tmp
	ldx	src+1
	ldy	src
	lda	dst
	sbc	tmp
	sta	src
	lda	dst+1
	sbc	tmp+1
	sta	src+1
bra5;-
	jsr	getput
	jsr	dececx
	ora	ecx+1
	bne	bra5;-
	sty	src
	stx	src+1
	jmp	dzx7s_main_loop;bra

dececx
	lda	ecx
	bne	bra2;+
	dec	ecx+1
bra2;+
	;dec
	sec
	sbc #1

	sta	ecx
	rts

getput
	jsr	getsrc

putdst
	sty tmpy
	ldy #0
	sta	(dst),y
	ldy tmpy
	inc	dst
	bne	bra3;+
	inc	dst+1
bra3;+
	rts

getsrc
	sty tmpy
	ldy #0
	lda	(src),y
	ldy tmpy
	inc	src
	bne	bra4;+
	inc	src+1
bra4;+
	rts
